package models

import (
	"log"

	"github.com/sujit-baniya/fiber-boilerplate/app"
	"gorm.io/gorm"
)

type VcfVcard struct {
	gorm.Model
	Vcf        string `json:"vcf" gorm:"column:vcf"`
	UsuarioID string `json:"usuario" gorm:"column:usuario"`
	Email     string `json:"email" gorm:"column:email"`
	VcardID   string `json:"vcard_id" gorm:"column:vcard_id"`
}

// TableName asegura que GORM use la tabla 'vcfvcard'
func (VcfVcard) TableName() string {
	return "vcfvcard"
}

// GetAllVcfVcard obtiene todos los registros de VcfVcard con paginación y búsqueda
func GetAllVcfVcard(limit, offset int, search string) ([]VcfVcard, int64, error) {
	var items []VcfVcard
	var total int64
	db := app.Http.Database.DB.Model(&VcfVcard{})

	// Si se pasa un término de búsqueda, lo aplicamos en la consulta
	if search != "" {
		db = db.Where("email LIKE ?", "%"+search+"%")
	}

	// Contamos el total de registros
	if err := db.Count(&total).Error; err != nil {
		log.Printf("Error counting VcfVcard: %v", err)
		return nil, 0, err
	}

	// Obtenemos los registros con paginación
	if err := db.Order("id DESC").Limit(limit).Offset(offset).Find(&items).Error; err != nil {
		log.Printf("Error retrieving VcfVcard: %v", err)
		return nil, 0, err
	}

	return items, total, nil
}

// CreateVcfVcard crea un nuevo registro de VcfVcard en la base de datos
func CreateVcfVcard(vcfVcard *VcfVcard) error {
	if err := app.Http.Database.DB.Create(&vcfVcard).Error; err != nil {
		return err
	}
	return nil
}

// UpdateVcfVcard actualiza un registro de VcfVcard existente
func UpdateVcfVcard(vcfVcard *VcfVcard) error {
	if err := app.Http.Database.DB.Model(&vcfVcard).Updates(vcfVcard).Error; err != nil {
		return err
	}
	return nil
}

// DeleteVcfVcard elimina un registro de VcfVcard de la base de datos
func DeleteVcfVcard(vcfVcard *VcfVcard) error {
	if err := app.Http.Database.DB.Delete(&vcfVcard).Error; err != nil {
		return err
	}
	return nil
}
